#include<R_ext/Lapack.h>
/* Genz's routine for computing bivariate normal integral */
double F77_NAME(bvnmvn)(double *lower, 
			double *upper, 
			int* infin, 
			double *correl);
		       
void allocate();

void deallocate();

void read_dimensions(const int *num_categ,
		     const int *num_regr,
		     const int *num_auto_corr,
		     const int *is_random_effect,
		     const int *dim_data, 
		     const int *dim_tot_data,
		     const int *num_periods,
		     const int *num_subjects);
		       
void read_order_pair_lik(const int *order_pair_lik);

void read_data(const int *data_input);

void read_covariates(const double *design_matrix_input);

void read_dynamic_categories(const int *dynamic_categ_input);

void read_index_subjects(const int *index_subjects_input);
		       
static void read_parameters(const double *param);

void read_approx_hessian(const int *ah);

static void build_limits(const int data,
			 const double regr, 
			 const double sd,
			 double* lim_inf,
			 double* lim_sup,
			 int* infin);

void logPair(const double *param,
	     double *logPair);
		       
static void logPair_period();

static void prob_pair(const int position,
		      const int distance_neigh,
		      double *result);

void score_info_logPair(const double *param,
			double *score,
			double *var_score,
			double *info,
      int approx_hessian);

static void score_info_logPair_period();

void score_info_log_prob_pair(const int position,
			      const int distance_neigh,
			      double *score,
			      double *info,
			      int approx_hessian);

static double dnorm2(const double x1,
		     const double x2,
		     const double rho);

static double der_dnorm2(const double x1,
		     const double x2,
		     const double rho);
